  ; whatlist
  PL_ROASTER          equ 1
  PL_VISIBLELIST      equ 2
  PL_INVISIBLELIST    equ 3
  PL_TEMPVISIBLELIST  equ 4
  PL_IGNORELIST       equ 5
  PL_DB               equ 6
  PL_NIL              equ 7  ; not in list

  ; connection state
  PCS_DISCONNECTED     equ 1
  PCS_CONNECTED        equ 2
  PCS_CONNECTING       equ 3

  ; whatwindow
  PW_ROASTER           equ 1
  PW_CHAT              equ 2
  PW_PREFERENCES       equ 3

  ; status
  PS_ONLINE            equ 0
  PS_OCCUPIED          equ 1
  PS_DND               equ 2
  PS_NA                equ 3
  PS_AWAY              equ 4
  PS_F4C               equ 5  ; free for chat
  PS_OFFLINE           equ 6
  PS_UNKNOWN           equ 7

  ; visibility
  PV_INVISIBLE         equ 0
  PV_PRIVACY           equ 1
  PV_NORMAL            equ 2
  PV_ALL               equ 3

  ; messages
  PM_GET     equ 1    ; asking data
  PM_DATA    equ 2    ; posting datas (reply)
  PM_EVENT   equ 3    ; event notification
  PM_ABORT   equ 4    ; abort event (reply)
  PM_CMD     equ 5    ; exec command
  PM_ACK     equ 6    ; ack to request (reply)
  PM_ERROR   equ 7    ; error (reply)

  ; events
  PE_INITIALIZE          equ 01
  PE_FINALIZE            equ 02
  PE_PREFERENCES         equ 03
  PE_CONNECTED           equ 04
  PE_DISCONNECTED        equ 05
  PE_MSG_GOT             equ 06
  PE_MSG_SENT            equ 07
  PE_CONTACTS_GOT        equ 08
  PE_CONTACTS_SENT       equ 09
  PE_URL_GOT             equ 10
  PE_URL_SENT            equ 11
  PE_ADDEDYOU_GOT        equ 12
  PE_ADDEDYOU_SENT       equ 13
  PE_AUTHREQ_GOT         equ 14
  PE_AUTHREQ_SENT        equ 15
  PE_AUTH_GOT            equ 16
  PE_AUTH_SENT           equ 17
  PE_AUTHDENIED_GOT      equ 18
  PE_AUTHDENIED_SENT     equ 19
  PE_GCARD_GOT           equ 20
  PE_GCARD_SENT          equ 21
  PE_AUTOMSG_GOT         equ 22
  PE_AUTOMSG_SENT        equ 23
  PE_AUTOMSG_REQ_GOT     equ 24
  PE_AUTOMSG_REQ_SENT    equ 25
  PE_EMAILEXP_GOT        equ 26
  PE_EMAILEXP_SENT       equ 27
  PE_LIST_ADD            equ 28
  PE_LIST_REMOVE         equ 29
  PE_STATUS_CHANGED      equ 30
  PE_USERINFO_CHANGED    equ 31
  PE_VISIBILITY_CHANGED  equ 32
  PE_WEBPAGER_GOT        equ 33
  PE_WEBPAGER_SENT       equ 34
  PE_FROM_MIRABILIS      equ 35
  PE_UPDATE_INFO         equ 36
  PE_XSTATUSMSG_SENT     equ 223 ; INT uin, BYTE xstcode, ISTRING xstname, ISTRING xsttext
  ; replies:
  ; PM_ABORT
  ; PM_DATA ISTRING xstname, ISTRING xsttext
  PE_XSTATUSMSG_REQ_GOT equ 224; INT uin
  ; replies: PM_ABORT
  PE_PACKET_GOT         equ 80
  PE_PACKET_SENT     equ 81

  ; get
  PG_USER               equ 01
  PG_CONTACTINFO        equ 02
  PG_DISPLAYED_NAME     equ 03
  PG_TIME               equ 04
  PG_LIST               equ 05
  PG_NOF_UINLISTS       equ 06
  PG_UINLIST            equ 07
  PG_AWAYTIME           equ 08
  PG_ANDRQ_PATH         equ 09
  PG_USER_PATH          equ 10
  PG_ANDRQ_VER          equ 11
  PG_ANDRQ_VER_STR      equ 12
  PG_USERTIME           equ 13
  PG_CONNECTIONSTATE    equ 14
  PG_WINDOW             equ 15
  PG_AUTOMSG            equ 16
  PG_CHAT_UIN           equ 201

  ; acks
  PA_OK             equ 01
                    
  ; errors
  PERR_ERROR          equ 01
  PERR_BAD_REQ        equ 02
  PERR_NOUSER         equ 03
  PERR_UNEXISTENT     equ 04
  PERR_FAILED_FOR     equ 05
  PERR_UNK_REQ        equ 06
                      
  ; commands         
  PC_SEND_MSG         equ 01
  PC_SEND_CONTACTS    equ 02
  PC_SEND_ADDEDYOU    equ 03
  PC_LIST_ADD         equ 04  
  PC_LIST_REMOVE      equ 05
  PC_SET_STATUS       equ 06
  PC_SET_VISIBILITY   equ 07
  PC_QUIT             equ 08
  PC_CONNECT          equ 09
  PC_DISCONNECT       equ 10
  PC_SET_AUTOMSG      equ 11
  PC_SEND_AUTOMSG_REQ equ 12
  PC_PLAYSOUND        equ 101
  PC_PLAYSOUNDFN      equ 102
  PC_RELOAD_THEME     equ 107
  PC_RELOAD_LANG      equ 108
  PC_ADD_MSG          equ 111  ; (uin : Integer, time: TDateTime, msg : String)
  PC_ADD_TO_INPUT     equ 112  ; (msg : String)
  PC_ADDBUTTON        equ 201
  PC_MODIFY_BUTTON    equ 202
  PC_DELBUTTON        equ 203
  PC_GET_PACKET       equ 80
  PC_SEND_PACKET      equ 81